# -*-coding: utf-8 -*-
#
# File: Plone2Postgresql/views.py
#
# Copyright (c) 2007 Redomino
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

"""
$Id$
"""

__author__ = """Fabrizio Reale <fabrizio.reale@redomino.com>"""
__docformat__ = 'plaintext'
__licence__ = 'GPL'


from Products.Five  import BrowserView
from zope.event import notify
from zope.interface import implements


from Products.CMFCore.utils import getToolByName
from Products.Plone2Postgresql.interfaces import ISQLExportableProvider
import psycopg2


class SQLExportableProvider(BrowserView):

    implements(ISQLExportableProvider)

    def __init__(self, context, request):
        self.context = context
        self.request = request

    def create_view(self):
	""" Create Postgresql View """
	
	context = self.context
	dbname=self.request.db_name
	user=self.request.username
	host=self.request.host
	password=self.request.password
	view_name=self.request.view_name
	type_name = view_name+'_type'
	function_name = view_name+'_function'
	curl = self.context.absolute_url()
	conn = psycopg2.connect("dbname=%s user=%s host=%s password=%s" % (dbname, user, host, password));
	cur = conn.cursor()
	conn.set_isolation_level(0)
	fields = context.getCustomViewFields()
	create_query="""
	DROP TYPE IF EXISTS %s CASCADE;
	CREATE TYPE %s AS (
	""" % (type_name, type_name,)
	len_fields = len(fields)
	for cont in range(len_fields):
		create_query += (fields[cont]+' text')
		if cont < len_fields-1: 
			create_query += ','
	create_query += """);
	CREATE OR REPLACE FUNCTION %s()
 	RETURNS SETOF %s AS
	$BODY$
	import xmlrpclib
	server = xmlrpclib.ServerProxy('%s')
	return server.export2pgsql()
	$BODY$
 	LANGUAGE 'plpythonu';
	CREATE OR REPLACE VIEW "%s" AS SELECT * from %s();
	""" % (function_name, type_name, curl, view_name, function_name)
	cur.execute(create_query)
	putils = getToolByName(self, 'plone_utils')
        putils.addPortalMessage('Postgresql View Created')
        self.request.RESPONSE.redirect(curl)